C  FORTRAN - 20/08/1999
C
C
C     PROGRAMA BERTV -----   VERSION FORTRAN LINUX
C    
C     Programa original utilizado en la HP-1000 OALP.
C     
C     Publicacin original:
C
C     Adaptado y mejorado:  Rodolfo Barb.
C
C     CUIDADO ------   VERSION PRELIMINAR --- V0.94
C
C     Uso de linea de comando: Federico Bareilles.
C
C -------------------------------------------------------------------
C    Historia
C        v0.92: version original preliminar
C        v0.93: se introdujo un STOP si la iteracion no converge
C        v0.94: variante si Excentricidad es fija
C        v0.95: Agrego uso de linea de comando (FAB)
C -------------------------------------------------------------------
C    Entrada de Datos:
C           
C        Archivo de 6 columnas
C        1) Da juliano de la observacin
C        2) Velocidad Radial
C        3) Peso
C        4) 
C        5) Primaria=0, o bien Secundaria=1
C        6) Espectrgrafo 0,1,2,3,4
C--------------------------------------------------------------------
C    Las Dimensiones deben ser las siguientes:
C
C        G(5,5) = cuando no se usan ms de 5 espectrgrafos.
c          V(5) = tambin debe cambiar segun el nmero de espectrgrafos.
c        T(500) = permite incluir hasta 500 observaciones.
c    OBSV,IW,KM = deben cambiar de acuerdo con ese nmero.
C    PR,C,CK,AI = no cambian nunca.
C           MAX = I debe coincidir con G(I,I).
C           LIW = unidad de entrada.
C           IIP = unidad de salida
C
C -------------------------------------------------------------------
C    Los datos a suministrar son:
C
C       KSN = N de identificacin de la estrella
C    A1, B1 = valor absoluto de la velocidad mxima y mnima respectivamente
C             medidas con respecto a V0.
C        Z1 = area positiva de la curva desde la mxima velocidad radial hasta
C             velocidad radial cero respecto de V0.
C        Z2 = area negativa de la curva desde la mnima velocidad radial hasta
C             velocidad radial cero respecto de V0.
C       T01 = poca en que la primera componente atraviesa el nodo ascendente
C             o poca de velocidad radial mxima.
C        V0 = velocidad radial del centro de masa del sistema
C         P = perodo en das.
C    A2, B2 = idem para segunda componente.
C       IFP = 0 cuando P SI debe ser mejorado; 1 cuando NO debe.
C     IPREC = 0 cuando NO se pide precisin a alcanzar; 1 SI se pide.
C      ISW1 = indica el mximo de iteraciones en una corrida del programa.
C      ISW4 = vale 1 cuando la excentricidad es >.05 y vale 2 cuando es <.05
C
C------------------------------------------------------------------------------
C------------------------------------------------------------------------------
C
C     PROGRAMA BERTIAU PARA EL CALCULO DE ELEMENTOS ORBITALES DE SISTEMAS
C     BINARIOS
C
C------------------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER BUF*120,NQUIER*1,MET*11
      DIMENSION G(5,5),A(11),F(11),T(500),V(5),OBSV(500),S(11,12),
     1IW(500),KM(500),PR(6),C(45),CK(2),AI(2),OBSV2(500),KSTAR(500),
     1FASE(500),OBSK(500),VRC(500),FAS1(500),FAS2(500),OBSV1(500)
c------------------------------------------------------------------------------
      logical no_graph
      character argument*80, file_data*120, output_file*120
      integer i
c------------------------------------------------------------------------------

      ISW4 = 1
      IFP = 0
      IFE = 0
      no_graph = .true.
      file_data = ''
      output_file ='soluc.bar' 
      i = 0
      call getarg(i, argument)
      do while(argument .ne. '')
         if( argument .eq. '-d')then
            i = i + 1
            call getarg(i, file_data)
            BUF = file_data
            no_graph = .false.
         endif
         if( argument .eq. '-n')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) NVELO
         endif
         if( argument .eq. '-V0')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) V0
         endif
         if( argument .eq. '-A1')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) A1
         endif
         if( argument .eq. '-B1')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) B1
         endif
         if( argument .eq. '-Z1')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) Z1
         endif
         if( argument .eq. '-Z2')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) Z2
         endif
         if( argument .eq. '-P')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) P
         endif
         if( argument .eq. '-T')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) T01
         endif
         if( argument .eq. '-A2')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) A2
         endif
         if( argument .eq. '-A2')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) A2
         endif
         if( argument .eq. '-B2')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) B2
         endif
         if( argument .eq. '-sterne')then
            ISW4 = 2
         endif
         if( argument .eq. '-pfijo')then
            IFP = 1
         endif
         if( argument .eq. '-efija')then
            IFE = 1
         endif
         if( argument .eq. '-e')then
            i = i + 1
            call getarg(i, argument)
            read(argument,*) ECCINP
         endif
         if( argument .eq. '-o')then
            i = i + 1
            call getarg(i, output_file)
         endif
         i = i + 1
         call getarg(i, argument)
      enddo

      if( no_graph )then
         write(*,*) 'Modo normal'
      else
         write(*,*) 'Modo grafico'
      endif

      IIP=11
      OPEN(IIP,FILE=output_file)
      KL=0
      IESCRI=0
      MAX=5
      DO  K=1,MAX
         DO  J=1,MAX
            G(K,J)=0.
         enddo
         G(K,K)=1.
      enddo
      PI=3.1415927
      PI2=2.*PI
      IPREC=0
      ISW1=50
      
      if(no_graph)then
         WRITE(*,*)
         WRITE(*,7575) 
 7575    FORMAT(T5,'***** Bart v0.95, (Bertiau modificado), 19-09-1999 ****
     1        '/)
         WRITE(*,1258)
 1258    FORMAT(' Nombre del archivo de datos: ',$)
         READ(*,1259)BUF
 1259    FORMAT(A40)
         WRITE(*,1236)
 1236    FORMAT('      Numero de datos (<500): ',$)
         READ(*,1004)NVELO
 1004    FORMAT(I3)
         WRITE(*,1260)
 1260    FORMAT('           V0, A1, B1 (km/s): ',$)
         READ(*,*)V0,A1,B1
         WRITE(*,1261)
 1261    FORMAT('               Z1, Z2 (Z2<0): ',$)
         READ(*,*)Z1,Z2
         WRITE(*,1262)
 1262    FORMAT('              Periodo (dias): ',$)
         READ(*,*)P
         WRITE(*,1210)
 1210    FORMAT('   Epoca de Veloc. max. (DJ): ',$)
         READ(*,*)T01
         WRITE(*,1263)
 1263    FORMAT(/'         A2, B2 (km/s; si NO HAY, poner 0,0): ',$)
         READ(*,*)A2,B2
         WRITE(*,1265)
 1265    FORMAT(' Metodos: Sterne, 0 (e<0.05); Schlesinger, 1: ',$)
         READ(*,*)ISW4
         IF(ISW4.EQ.0)ISW4=2
         WRITE(*,2265)
 2265    FORMAT('        Periodo variable, 0; Periodo fijo, 1: ',$)
         READ(*,*)IFP
         WRITE(*,2266)
 2266    FORMAT('        Excentricidad variable, 0; fija, 1: ',$)
         READ(*,*)IFE
         IF(IFE.EQ.1) THEN
            WRITE(*,2267)    
 2267       FORMAT('         EXCENTRICIDAD:  ',$)
            READ(*,*)ECCINP
         ENDIF
      endif
      
      WRITE(IIP,*)'  ARCHIVO:   ', BUF
      WRITE(IIP,2002)NVELO
 2002 FORMAT(/' NUMERO DE DATOS : ',I4)
      WRITE(IIP,2003)V0,A1,B1
 2003 FORMAT(/' V0, A1, B1 (KM/S): ',3F8.2)
      WRITE(IIP,2004)Z1,Z2
 2004 FORMAT(' Z1, Z2 : ',2F8.2)
      WRITE(IIP,2005)P,T01
 2005 FORMAT(' PERIODO',F13.7,'   DIAS;    UNA EPOCA DE VMAX:  ',F12.3)
      WRITE(IIP,2006)A2,B2
 2006 FORMAT(' A2, B2 (KM/S): ',2F8.2)

      AMU=PI2/P

 11   PR(1)=.006/(P*P)
      IF((.000001*AMU-PR(1)).LE.0.)GOTO 14
      PR(1)=.000001*AMU

 14   PR(2)=.001
      PR(3)=.0001
      PR(4)=.001
      PR(5)=.2
      PR(6)=.2
        
 15   C(45)=0.
      MAX=0
      KCJ=5
      KSW3=3
      ISENIA=0
      ER=0.
      
      OPEN(3,STATUS='OLD',FILE=BUF)
      
      DO K=1,NVELO
      READ(3,*)T(K),OBSV(K),WK,KMK,KCK,C(44)
      IF(KCK.EQ.0)THEN
         KSTAR(K)=0
      ELSE
         KSTAR(K)=1
      ENDIF
      IF(C(44).EQ.0.)GOTO 19
      C(45)=1.
      GO TO 33
 19   IF(KMK.EQ.0)GOTO 33
      IF(MAX-KMK)23,25,25
 23   MAX=KMK
 25   IF(KCK.EQ.0)GOTO 31
      KCJ=6
      KMK=-KMK
 31   KM(K)=KMK
      IW(K)=WK*10.
      ENDDO
      
      CLOSE(3)

 33   N=K-1
      IK=0
      IT=0
      APB=A1+B1
      AMB=A1-B1
      AB=A1*B1
      VK=(Z1+Z2)/(Z2-Z1)
      CK(1)=APB/2.
      CK(2)=(A2+B2)/2.
      IF(IFE.EQ.1) THEN
         ECC=ECCINP
      ELSE
         ECC=SQRT(AMB**2+4.*AB*VK*VK)/APB
      ENDIF

      OMR=PI/2.
      
      IF(AMB.EQ.0.)GOTO 43
      OMR=DATAN(DSQRT(AB)*VK*2./AMB)
      
      IF(AMB.GE.0.)GOTO 43
      OMR=OMR+PI
      
 43   AB=OMR/2.
      
      R=DCOS(AB)
      P=-PI
      
      IF(R.EQ.0.)GOTO 47
      P=DATAN(DSQRT((1.-ECC)/(1.+ECC))*DSIN(AB)/R)*(-2)
      
 47   IF((IK-1).EQ.0)GOTO 175
      T0=(ECC*DSIN(P)-P)/AMU+T01
      
      IF((IK-2).EQ.0)GOTO 177
      
      DO K=1,MAX
         V(K)=V0
      ENDDO
      
      K2CO=1
      KCL=KCJ+1
      LL=KCJ-6
      L=MAX+KCJ
      LP1=L+1
      LMM1=L-1
      L2=L-IFP
      IFP=IFP+1
      IFP3=IFP+1
      KKL=IFP-2
      LM1=L-IFP
      
      WRITE(11,1266)
 1266 FORMAT(//,'V(I)',T10,'K(1)',T17,'K(2)',T24,'EXC',T28,'OMEGA',
     1T37,'EP.PERIAST.',T49,'EPOCA VMAX',T64,'2.PI/P',T74,'IT',
     2T77,'MET')
55      WRITE(11,93)V(1),CK(1),CK(2),ECC,OMR,T0,T01,AMU,IT,IK
93      FORMAT(3(1X,F6.2),F5.3,F8.5,2(F12.4),1X,E13.8,I3,I2)

        IF((MAX-1).LE.0)GOTO 61

        DO J=2,MAX
           WRITE(11,93)V(J)
        ENDDO
        
61      IF(KSW3.EQ.0)GOTO 501

        IF((IT-ISW1).LE.0)GOTO 65
           GO TO 185
           
65      IT=IT+1

        DO K=1,L
        DO J=K,LP1
           S(K,J)=0.
        ENDDO
        ENDDO
        
        IF((ECC-.05).LT.0.)GOTO 201
101         IK=1
           
521     C(43)=DSIN(OMR)*ECC
        C(42)=1.-ECC**2
        C(41)=DSQRT(C(42))
        C(40)=C(42)*C(41)
        C(38)=DCOS(OMR)
        C(37)=ECC*C(38)
        C(36)=(1.+ECC)/C(41)
313     C(39)=0.
        AS=0.
        
C******* CAMBIO EN EL LOOP 145 PARA QUE NO HAYA TRANSFERENCIA DENTRO
C        DEL BLOQUE DO        
C       DO 145 K=1,N
C
        K=0
 1450   K=K+1
 
        ISENI1=0
        ISENI2=0
        OK=OBSV(K)
        TK=T(K)
 
        IF(IK.EQ.2)GOTO 207
           TK0=TK-T0
           AB=TK0*AMU
           EO=-1.
           
        IF(AB)102,108,104
102        EO=1.

104     IF(DABS(AB).LE.PI)GOTO 108
           AB=PI2*EO+AB
           GO TO 104
           
108     EO=0.

        IF(DABS(AB).LT.1D-10)GOTO 113
           VK=DSIN(AB)*ECC+AB
           EO=DSIN(VK)*ECC+AB
           
105     VK=(-DSIN(EO)*ECC-AB+EO)/(DCOS(EO)*ECC-1.)+EO

        IF(DABS((EO-VK)/EO).LE.0.000001)GOTO 109
        
        EO=VK
        ISENI1=ISENI1+1
        
        IF(ISENI1.LE.40)GO TO 105
        
        WRITE(IIP,19902)

        WRITE(*,*)
        WRITE(*,19902)
19902   FORMAT(' Solucion NO convergente ')
c     WRITE(*,19903)     
c     19903      FORMAT(' Quiere seguir (s/n)? ',$)
c     READ(*,'(A)')NQUIER
c     IF((NQUIER.EQ.'n').OR.(NQUIER.EQ.'N'))STOP
        goto 2020
 700    KSW3=1
        
        IF((IK-3)*LL)300,2020,300

        
109     AB=EO/2.
113     WK=DCOS(AB)
        VK=PI
        
        IF(WK.EQ.0.)GOTO 117
           VK=DATAN(DSIN(AB)*C(36)/WK)*2.
        
117     C(35)=DCOS(OMR+VK)
        A(5)=C(35)+C(37)
        
        IF(((IK-3)*KSW3).EQ.0)GOTO 127
        
           C(34)=DSIN(OMR+VK)
           C(33)=DCOS(VK)*ECC
           C(32)=((1.+C(33))**2)*C(34)/C(40)
           A(4)=C(32)*AMU
           A(3)=-C(34)-C(43)
           A(2)=(-2.-C(33))*C(34)*DSIN(VK)/C(42)+C(38)
        
           IF(KKL.EQ.0)GOTO 127
              A(1)=-TK0*C(32)
           
127     WK=IW(K)

        WK=.1*WK
        KCK=1

        IF(KM(K).GT.0)GOTO 126
           KCK=2
           
126     KMK=IABS(KM(K))

        IF(IK.EQ.3)GOTO 315
        
        COEF=G(1,KCK)*CK(1)-G(2,KCK)*CK(2)
        OBS=A(5)*COEF+V(KMK)
        DEL=OK-OBS
        A(LP1)=DEL
        
        IF(KSW3.EQ.0)GOTO 139
        
        A(6)=-A(5)*G(2,KCK)
        A(5)=A(5)*G(1,KCK)
        
        DO J=IFP,4
           A(J)=A(J)*COEF
        ENDDO
        
        DO M=KCL,L
           L4=M-KCJ
           A(M)=G(KMK,L4)
        ENDDO
        
        DO M=IFP,L
           AB=A(M)*WK
           DO J=M,LP1
              S(M,J)=A(J)*AB+S(M,J)
           ENDDO
        ENDDO
        
        ISENI2=ISENI2+1
        
        GO TO 143
        
315     IF(K2CO.EQ.0)GOTO 319

        S(1,2)=(OK-V(KMK))*A(5)*WK+S(1,2)
        S(1,1)=A(5)**2*WK+S(1,1)
        
        GO TO 145
        
319     OBS=V(KMK)+A(5)*CK(2)
        DEL=OK-OBS
        
139     CONTINUE

C------ ENCABEZAMIENTO A LA TABLA --

        IF(IESCRI.EQ.0)THEN 
        WRITE(IIP,"(/,' DIA JULIANO',T18,'OBS.',T27,'CALC.',T38,
     1'(O-C)',T50,'COMP.',T59,'PESO',T66,'ESPECTR.',/)")
        IESCRI=1
        ENDIF
        
C-----------------------------------

        KL=KL+1
        OBSK(KL)=OBS

141     WRITE(IIP,82)TK,OK,OBS,DEL,KCK,WK,KMK
82      FORMAT (F12.4,F10.2,F10.2,F10.2,2X,I8,3X,F7.2,2X,I5)

143     C(39)=WK*DEL**2+C(39)
        AS=AS+WK

C*****************************************
C    AQUI CIERRO EL DO 145 PARA NO TRANSFERIR DENTRO DE EL
C
C145     CONTINUE
C

145     IF(K.LT.N)GOTO 1450

        IF(2*IK+K2CO-6)147,321,317
147     AB=N-L2

        ER=DSQRT(C(39))*.673
        ET=ER/DSQRT(AB)
        ER=ER/DSQRT(AS)

        WRITE(IIP,100)ER
100     FORMAT('E.P. ',F7.2,/)

401     IF(KSW3.EQ.0)GOTO 523

        DO J=IFP3,L
           K2=J-1
           DO M=IFP,K2
              S(J,M)=S(M,J)/S(M,M)
           ENDDO
           DO K=J,LP1
              AB=S(J,K)
              DO M=IFP,K2
                 AB=AB-S(J,M)*S(M,K)
              ENDDO   
              S(J,K)=AB
           ENDDO
        ENDDO      
        
        S(L,LP1)=S(L,LP1)/S(L,L)
        
        DO M=1,LM1
           K=L-M
           M2=K+1
           VK=S(K,LP1)
           DO J=M2,L
              VK=VK-S(J,LP1)*S(K,J)
           ENDDO
           S(K,LP1)=VK/S(K,K)
        ENDDO
        
        DO M=IFP,L
           C(M)=S(M,LP1)
        ENDDO
           
        IF(IK.EQ.2)GOTO 249
        
149     DO M=IFP,5
           IF(DABS(C(M)).GT.PR(M))GOTO 167
        ENDDO   

        IF(LL.NE.0)GOTO 163
        
        IF(DABS(C(6)).GT.PR(5))GOTO 167
        
163     DO M=KCL,L
           IF(DABS(C(M)).GT.PR(6))GOTO 167
        ENDDO
        
        KSW3=0
        
167     IF(IFE.EQ.1) THEN
           ECC=ECC
           ELSE
              ECC=ECC+C(2)
        ENDIF
        OMR=OMR+C(3)
        
        IF(KKL.EQ.0)GOTO 171
           AMU=AMU+C(1)

171     IF(IK.EQ.2)GOTO 273
           T0=T0+C(4)
           
        GO TO 43
        
175     T01=(-DSIN(P)*ECC+P)/AMU+T0
177     CK(1)=CK(1)+C(5)

        IF(LL.NE.0)GOTO 181
           CK(2)=CK(2)+C(6)
           
181     DO M=KCL,L
           J=M-KCJ
           V(J)=V(J)+C(M)
        ENDDO   

        IF(ECC.GE.0.)GOTO 55 
        
        ECC=-ECC
        OMR=OMR-PI
        
        IF(OMR.GE.0.)GOTO 186
           OMR=OMR+PI2
           
186     T0=PI/AMU+T0

        GO TO 55

185     WRITE(IIP,95)
95      FORMAT('PRECISION NO ALCANZADA')

        KSW3=0
        
501     DO M=IFP,LMM1
           K=M+1
           DO J=K,L
              S(M,J)=0.
           ENDDO
        ENDDO
        
        DO M=IFP,L
           S(M,M)=1./S(M,M)
        ENDDO
           
        DO 519 M1=2,L2
           M=LP1-M1
           LM=M+1
           DO 519 L1=1,M1
              AB=0.
              J=LP1-L1
              IF(LM.GT.J)GOTO 515
                 DO KMK=LM,J
                    AB=S(KMK,M)*S(KMK,J)+AB
                 ENDDO
              IF(J.GE.L)GOTO 519
515           K=J+1
              DO KMK=K,L
                 AB=S(KMK,M)*S(J,KMK)+AB
              ENDDO   
519     S(M,J)=S(M,J)-AB
                
        GO TO 521
        
523     DO M=IFP,L
           F(M)=SQRT(S(M,M))*ET
        ENDDO
           
        IF(KKL.NE.0)GOTO 529
           F(1)=0.
           
529     OMD=OMR*57.295780
        F(1)=PI2*F(1)/(AMU*AMU)
        P=PI2/AMU
        
        IF(IK.EQ.2)GOTO 287
187        AIK=86400.*C(41)/AMU
           AI(1)=AIK*CK(1)
           F(3)=F(3)*57.295780
           DA1=(ECC*F(2)/(1.-ECC*ECC)+F(1)/P+F(5)/CK(1))*AI(1)
        
        IF(LL.NE.0)GOTO 191
           AI(2)=AIK*CK(2)
           DA2=(ECC*F(2)/(1.-ECC*ECC)+F(1)/P+F(5)/CK(2))*AI(2)


191    IIPBIS=IIP
       WRITE(IIP,*)
       WRITE(IIP,"(15X,'ELEMENTOS DE LA PRIMERA COMPONENTE')")
       WRITE(IIP,*)
       WRITE(IIP,"(T5,'   A sin i ',T20,E12.6,T35,'',T41,E12.3,T57,'km'
     1 )")AI(1),DA1
       WRITE(IIP,702)CK(1),F(5)
  702  FORMAT(T5,'         K ',T17,F8.3,T35,'',T41,F8.3,T57,'km/s')
       WRITE(IIP,703)ECC,F(2)
  703  FORMAT(T5,'       Exc ',T21,F5.4,T35,'',T45,F5.4,T57)
       WRITE(IIP,704)OMD,F(3)
  704  FORMAT(T5,'     Omega ',T17,F9.3,T35,'',T41,F9.3,T57,'grad')
       WRITE(IIP,"(T5,'T. Periast ',T19,F12.4,T35,'',T38,F12.4,T57,'DJ'
     1 )")T0,F(4)
       WRITE(IIP,"(T5,'  T. V.Max ',T19,F12.4,T35,'',T38,F12.4,T57,'DJ'
     1 )")T01,F(4)
       WRITE(IIP,"(T5,'   Periodo ',T17,F13.8,T35,'',T41,F13.8,T57,
     1 'Dias')")P,F(1)
       IF(IK.EQ.2)THEN
          MET='Sterne     '
          ELSE
          MET='Schlesinger'
       ENDIF
       WRITE(IIP,"(T5,'    Metodo ',T17,A11,T35,'iter',T41,I4)")MET,IT
       WRITE(IIP,*)

C------------------------------------------------------------------------------
C
C       CALCULO DE LA FUNCION DE MASA
C
        CFMASS=1.0346E-07
        EXC1=(1.-ECC*ECC)
        FUMAS=CFMASS*EXC1**1.5*CK(1)**3*P
        
C------- ERROR (FALTA VERIFICAR)

        DFM=(3.*ECC*F(2)/(1.-ECC*ECC)+3.*F(5)/CK(1)+F(1)/P)*FUMAS
        
        DO M=1,MAX
           L4=M+KCJ
        WRITE(IIP,"(T5,'    V(',I1,')',T17,F9.3,T35,'',T41,F9.3,T57,
     1 'km/s')")M,V(M),F(L4) 
        ENDDO

C------- IMPRIME LA FUNCION DE MASA O CALCULA LA SEGUNDA COMPONENTE

323     IF((A2.EQ.0.).AND.(B2.EQ.0.)) THEN
        WRITE(IIP,"(T5,'    F(M) ',T17,F8.4,T35,'',T41,F8.4,T57,
     1 'Masas Sol')")FUMAS,DFM
         
         ELSE
                
        WRITE(IIP,"(/,15X,'ELEMENTOS DE LA SEGUNDA COMPONENTE',/)")
        WRITE(IIP,"(T5,'  A sin i ',T20,E12.6,T35,'',T41,E12.3,T57,'km'
     1  )")AI(2),DA2
        WRITE(IIP,"(T5,'        K ',T17,F8.3,T35,'',T41,F8.3,T57,'km/s'
     1  ,/)")CK(2),F(6)

C       ----------- AHORA IMPRIME LAS MASAS ----------
     
        QMASS=CK(1)/CK(2)
        DQMASS=(F(5)/CK(1)+F(6)/CK(2))*QMASS
        FMASS2=CFMASS*EXC1**1.5*CK(1)**3*(1.+1./QMASS)**2*P
        FMASS1=CFMASS*EXC1**1.5*CK(2)**3*(1+QMASS)**2*P
        DFM2=(3.*ECC*F(2)/EXC1+3.*F(5)/CK(1)
     1       +2.*DQMASS/((QMASS+1)*QMASS)+F(1)/P)*FMASS2
        DFM1=(3.*ECC*F(2)/EXC1+3.*F(6)/CK(2)
     1       +2.*DQMASS/(QMASS+1)+F(1)/P)*FMASS1

        WRITE(IIP,"(T5,'M1 sin3 i ',T18,F8.4,T35,'',T41,F8.4,T57,
     1  'M. Sol')")FMASS1,DFM1
        WRITE(IIP,"(T5,'M2 sin3 i ',T18,F8.4,T35,'',T41,F8.4,T57,
     1  'M. Sol')")FMASS2,DFM2
        WRITE(IIP,"(T5,' Q(M1/M2) ',T18,F8.4,T35,'',T41,F8.4)")
     1  QMASS,DQMASS
        
        ENDIF

        IIP=6
        IF(IIP.NE.IIPBIS)GOTO 191
        IIP=11

C--------------------- FIN IMPRESION --------------------------

        if( no_graph )then
        WRITE(*,8100)
8100    FORMAT(/'    Cambia fase? ',$)
        READ(*,'(A)')NQUIER
	endif

        IF((NQUIER.EQ.'n').OR.(NQUIER.EQ.'N'))THEN
            DFAS=0.
            GOTO 8200
        ENDIF

        IF(((NQUIER.EQ.'S').OR.(NQUIER.EQ.'s')).OR.((NQUIER.EQ.'Y')
     1.OR.(NQUIER.EQ.'y'))) THEN
8103         WRITE(*,8101)
8101         FORMAT('     Delta fase: ',$)
             READ(*,*)DFAS
             IF(DABS(DFAS).GT.1.5)GOTO 8103
         ENDIF

8200     IK=4
         goto 1000
c        WRITE(*,9999)
c9999    FORMAT('  Quiere seguir? ',$)
c        READ(*,'(A)')NQUIER
c
c        IF((NQUIER.EQ.'n').OR.(NQUIER.EQ.'N'))GOTO 1000
c
c        IF(((NQUIER.EQ.'S').OR.(NQUIER.EQ.'s')).OR.((NQUIER.EQ.'Y')
c     1.OR.(NQUIER.EQ.'y'))) GOTO 1

201     IF(IT.LT.3)GOTO 205

203     IF(ISW4.EQ.1)GO TO 101

205     IK=2

        GO TO 313

207     AB=(TK-T01)*AMU
        A(5)=DCOS(AB)
        A(4)=DSIN(AB)
        A(3)=2.*A(4)*A(5)
        A(2)=DCOS(2.*AB)
        A(4)=A(4)*AMU

        IF(KKL.EQ.0)GOTO 127
           A(1)=(T01-TK)*DSIN(AB)

        GO TO 127

249     C(31)=DSQRT(C(3)**2+C(2)**2)
        C(30)=DATAN(C(3)/C(2))
        AMB=AMB-2.*C(KCL)

        IF(AMB.GE.0.)GOTO 253
           C(30)=C(30)+PI

        GO TO 257

253     IF(C(30).GE.0.)GOTO 257
           C(30)=C(30)+PI2

257     C3=C(3)
        C2=C(2)
        C(3)=C(30)-OMR
        C(2)=C(31)-ECC

        GO TO 149

273     T01=T01+C(4)

        GO TO 43

287     C(29)=DSQRT((F(3)*C3)**2+(F(2)*C2)**2)/ECC
        F(3)=SQRT((F(2)*C3)**2+(F(3)*C2)**2)/(ECC**2)
        F(2)=C(29)

        GO TO 187

c300     IF(C(45).NE.0.)GOTO 1
300     IF(C(45).NE.0.)GOTO 2020

301     IK=3
        IT=1
        WK=0.
        KMK=0
        KCK=0
        C(44)=0.

305     IF(KMK.EQ.0)GOTO 309
           KM(K)=-KMK

308     IW(K)=WK*10.
309     N=K-1

c        IF(((KSW3-1)*N).EQ.0)GOTO 1
        IF(((KSW3-1)*N).EQ.0)GOTO 2020

        S(1,2)=0.
        S(1,1)=0.
        OMR=OMR-PI

        GO TO 521

317     CK(2)=S(1,2)/S(1,1)
        AI(2)=86400.*CK(2)*C(41)/AMU
        K2CO=0

        GO TO 313

321     AB=N-1.
        F(6)=DSQRT(C(39)/(AB*S(1,1)))*.673

        GO TO 323

1000    CLOSE(1)

C------------------------------------------------------------------------------
C
C       CALCULO DE DATOS PARA GRAFICOS
C
C------------------------------------------------------------------------------

        OPEN(2,FILE='vobs1.bar')
        OPEN(12,FILE='vobs2.bar')
C        OPEN(3,FILE='vcal.bar')

        DO 2010 I=1,NVELO
           FASE(I)=(T(I)-T0)/P
           FASE(I)=FASE(I)-DBLE(FLOAT(INT(FASE(I))))
           IF(T(I).GT.T0) GOTO 2010
              FASE(I)=FASE(I)+1.
 2010   CONTINUE

        NOBSV1=0
        NOBSV2=0

        DO I=1,NVELO
           IF(KSTAR(I).EQ.0)THEN
              NOBSV1=NOBSV1+1
              FAS1(NOBSV1)=FASE(I)+DFAS
              OBSV1(NOBSV1)=OBSV(I)
            ELSE
              NOBSV2=NOBSV2+1
              FAS2(NOBSV2)=FASE(I)+DFAS
              OBSV2(NOBSV2)=OBSV(I)
            ENDIF
            FASE(I)=FASE(I)+DFAS
        ENDDO


C        CALL ACOMODA(NVELO,FASE,OBSK,NT,FASE,OBSK)
C        WRITE(3,2011)(FASE(LL),OBSK(LL),LL=1,NT)

        CALL ACOMODA(NOBSV1,FAS1,OBSV1,NT,FASE,OBSV)
        WRITE(2,2011)(FASE(LL),OBSV(LL),LL=1,NT)

        CALL ACOMODA(NOBSV2,FAS2,OBSV2,NT,FASE,OBSV)
        WRITE(12,2011)(FASE(LL),OBSV(LL),LL=1,NT)


        CLOSE(2)
        CLOSE(12)
C        CLOSE(3)
  
        PREC=0.00001

C------- CURVAS CALCULADAS

        OPEN(4,FILE='vcur1.bar')
        CALL CURVA(CK(1),V(1),ECC,DFAS,PREC,OMR,FASE,VRC)
        CALL ACOMODA(100,FASE,VRC,NT,FASE,VRC)
        WRITE(4,2011)(FASE(LL),VRC(LL),LL=1,NT)
        IF(CK(2).EQ.0.)THEN
           OPEN(14,FILE='vcur2.bar')
           WRITE(14,*)
           CLOSE(14)
        ENDIF
        CLOSE(4)

        IF(CK(2).NE.0.)THEN 
           OPEN(14,FILE='vcur2.bar')
           OMR=OMR+PI
           CALL CURVA(CK(2),V(1),ECC,DFAS,PREC,OMR,FASE,VRC)
           CALL ACOMODA(100,FASE,VRC,NT,FASE,VRC)
           WRITE(14,2011)(FASE(LL),VRC(LL),LL=1,NT)
           CLOSE(14)
        ENDIF


2011    FORMAT(2F20.5)


 2020   STOP
        END

        SUBROUTINE CURVA(CK,V,ECC,DFAS,PREC,OMR,FASE,VRC)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION VRC(100),FASE(100),V(1)

        KMK=1
        PI=4.D0*DATAN(1.D0)
        PI2=PI*2.D0

        DO 79 J=1,100
           JF=J
           IF((50-JF).NE.0)GOTO 71
               AV=PI
               GOTO 73
  71       AM=JF*PI2/100.
           AE=AM
  74       AMC=AE-ECC*DSIN(AE)
           DAM=AM-AMC
           IF(DABS(DAM).LE.PREC)GOTO 75
              DAE=DAM/(1.-ECC*DCOS(AE))
              AE=AE+DAE
              GOTO 74
  75       TANV2=DSQRT((1.D0+ECC)/(1.D0-ECC))*DTAN(AE/2.D0)
           V2=DATAN(TANV2)
           AV=2.D0*V2
  73       VRC(J)=V(KMK)+CK*(DCOS(OMR+AV)+ECC*DCOS(OMR))
           FASE(J)=JF/100.
           FASE(J)=FASE(J)+DFAS
           IF(FASE(J).LE.1.)GOTO 79
              FASE(J)=FASE(J)-1.
  79    CONTINUE
        RETURN
        END


C------- SUBRUTINA PARA ACOMODAR LAS SALIDAS A GRAFICOS

        SUBROUTINE ACOMODA(N,X,Y,NT,ZX,ZY)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION X(500),Y(500),XA(500),YA(500),ZX(500),ZY(500)
        
        
        DO I=1,N
           IF(X(I).GE.0.5) THEN
             XA(I)=X(I)-1.
             YA(I)=Y(I)
             ELSE
             XA(I)=X(I)+1.
             YA(I)=Y(I)
           ENDIF
        ENDDO

        NT=2*N
        DO I=1,NT
           IF(I.LE.N)THEN
             ZX(I)=X(I)
             ZY(I)=Y(I)
             ELSE
             ZX(I)=XA(I-N)
             ZY(I)=YA(I-N)
           ENDIF
        ENDDO
        
        CALL SORT(NT,ZX,ZY)
        RETURN
        END

        SUBROUTINE SORT(N,X,Y)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION X(N),Y(N)
        NL1=N-1
        DO 1 I=1,NL1
           IP1=I+1
           DO 1 J=IP1,N
              IF(X(I).LE.X(J)) GOTO 1
                H=X(I)
                X(I)=X(J)
                X(J)=H
                H=Y(I)
                Y(I)=Y(J)
                Y(J)=H
   1    CONTINUE
        RETURN
        END

