/****************************************************************************
* Modulo : gbart_gtk.c
* Fecha  : 19/09/1999
* Autor  : Federico Bareilles
* Version: 0.1-0
* Descripcion:
*
* 
*****************************************************************************/
#include "gbart_gtk.h"
#include "gbart_gtk_callback.h"
#include "gbart.h"
#include "gbart_gtk_messages.h"

#define PERIODO_DIG  10
#define EXCENTRICIDAD_DIG  10
#define EPVMAX_DIG  10
#define V0_DIG  10
#define Z1_DIG  10
#define Z2_DIG  10
#define A1_DIG  10
#define B1_DIG  10
#define A2_DIG  10
#define B2_DIG  10


GtkWidget *window;
GtkWidget *filew;
GtkWidget *archivo_in;
GtkWidget *periodo_in;
GtkWidget *excentricidad_in;
GtkWidget *epoca_vel_max_in;
GtkWidget *V0_in;
GtkWidget *Z1_in;
GtkWidget *Z2_in;
GtkWidget *A1_in;
GtkWidget *B1_in;
GtkWidget *A2_in;
GtkWidget *B2_in;

/* No globales */
GtkWidget *check_primaria;
GtkWidget *check_secundaria;
/* END: no globales */


#if(0)
GtkWidget *text_entry_num_create(char *texto, gint longitud, gboolean horizontal, gint separator, GtkWidget **entry)
{
  GtkWidget *box;
  GtkWidget *label;
  GtkAdjustment *adj;

  if( horizontal ){
    box = gtk_hbox_new (FALSE, separator);
    gtk_container_set_border_width(GTK_CONTAINER (box), 5);
  }
  else
    box = gtk_vbox_new (FALSE, separator);
  gtk_widget_show(box);
 
  label = gtk_label_new (texto);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  /*  gtk_container_add (GTK_CONTAINER (box), label);*/
  gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 0);
  gtk_widget_show (label);
  
  /*
The GtkAdjustment struct contains the following fields. 

 gfloat lower;          the minimum value.
 gfloat upper;          the maximum value.
 gfloat value;          the current value.
 gfloat step_increment; the increment to use to make minor changes to the 
 value. In a GtkScrollbar this increment is used when the mouse is clicked 
 on the arrows at the top and bottom of the scrollbar, to scroll by a small 
 amount.
 gfloat page_increment; the increment to use to make major changes to the 
 value. In a GtkScrollbar this increment is used when the mouse is clicked in 
 the trough, to scroll by a large amount.
 gfloat page_size;      the page size. In a GtkScrollbar this is the size of 
 the area which is currently visible.
*/

  adj = (GtkAdjustment *) gtk_adjustment_new (0.0, 10.0, 1.0, 0.01,
                                              1.0, 0.0); 
  /**entry = gtk_entry_new_with_max_length( longitud);*/
  *entry = gtk_spin_button_new (adj, 1, 5);
  /*
  gtk_signal_connect(GTK_OBJECT(*entry), "activate",
		     GTK_SIGNAL_FUNC(general_entry_callback),
		     (gpointer) texto);
  */
  gtk_container_add (GTK_CONTAINER (box), *entry);
  /*  gtk_box_pack_start (GTK_BOX (box), *entry, FALSE, FALSE, 0);*/
  gtk_widget_show (*entry);       

  return box;
}
#endif



GtkWidget *text_entry_create(char *texto, gint longitud, gboolean horizontal, gint separator, GtkWidget **entry)
{
  GtkWidget *box;
  GtkWidget *label;


  if( horizontal ){
    box = gtk_hbox_new (FALSE, separator);
    gtk_container_set_border_width(GTK_CONTAINER (box), 5);
  }
  else
    box = gtk_vbox_new (FALSE, separator);
  gtk_widget_show(box);
 
  label = gtk_label_new (texto);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  /*  gtk_container_add (GTK_CONTAINER (box), label);*/
  gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 0);
  gtk_widget_show (label);
  

  *entry = gtk_entry_new_with_max_length( longitud);
  gtk_widget_set_usize(*entry, longitud << 3, 22);
  /*
  gtk_signal_connect(GTK_OBJECT(*entry), "activate",
		     GTK_SIGNAL_FUNC(general_entry_callback),
		     (gpointer) texto);
  */
  gtk_container_add (GTK_CONTAINER (box), *entry);
  /*  gtk_box_pack_start (GTK_BOX (box), *entry, FALSE, FALSE, 0);*/
  gtk_widget_show (*entry);       

  return box;
}


GtkWidget *primaria_create()
{
  GtkWidget *frame1;
  GtkWidget *vbox;
  GtkWidget *entry;

  gboolean HORIZ = TRUE;
 
  frame1 = gtk_frame_new(NULL);
  gtk_frame_set_label( GTK_FRAME(frame1), "Primaria" );
  gtk_frame_set_shadow_type( GTK_FRAME(frame1), GTK_SHADOW_ETCHED_IN);

  /* vbox --------------------------------------------------------------*/
  vbox = gtk_vbox_new (FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);
  gtk_container_add(GTK_CONTAINER(frame1), vbox);
  gtk_widget_show(vbox); 

  entry = text_entry_create("A1:", A1_DIG, HORIZ, 5, &A1_in);
  /*  gtk_container_add(GTK_CONTAINER(vbox), entry);*/
  gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, FALSE, 0);
  gtk_widget_show(entry);

  entry = text_entry_create("B1:", B1_DIG, HORIZ, 5, &B1_in);
  /*  gtk_container_add(GTK_CONTAINER(vbox), entry);*/
  gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, FALSE, 0);
  gtk_widget_show(entry);

  return frame1;
}


GtkWidget *secundaria_create()
{
  GtkWidget *frame1;
  GtkWidget *vbox;
  GtkWidget *entry;

  gboolean HORIZ = TRUE;
 
  frame1 = gtk_frame_new(NULL);
  gtk_frame_set_label( GTK_FRAME(frame1), "Secundaria" );
  gtk_frame_set_shadow_type( GTK_FRAME(frame1), GTK_SHADOW_ETCHED_IN);

  /* vbox --------------------------------------------------------------*/
  vbox = gtk_vbox_new (FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);
  gtk_container_add(GTK_CONTAINER(frame1), vbox);
  gtk_widget_show(vbox); 

  entry = text_entry_create("A2:", A2_DIG, HORIZ, 5, &A2_in);
  /*  gtk_container_add(GTK_CONTAINER(vbox), entry);*/
  gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, FALSE, 0);
  gtk_widget_show(entry);

  entry = text_entry_create("B2:", B2_DIG, HORIZ, 5, &B2_in);
  /*  gtk_container_add(GTK_CONTAINER(vbox), entry);*/
  gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, FALSE, 0);
  gtk_widget_show(entry);

  return frame1;
}


GtkWidget *parametros_create()
{
  GtkWidget *frame1, *frame2;
  GtkWidget *hbox;
  GtkWidget *vbox;
  GtkWidget *entry;

  gboolean HORIZ = TRUE;
 
  frame1 = gtk_frame_new(NULL);
  gtk_frame_set_label( GTK_FRAME(frame1), "Parametros" );
  gtk_frame_set_shadow_type( GTK_FRAME(frame1), GTK_SHADOW_ETCHED_IN);

  /* hbox --------------------------------------------------------------*/
  hbox = gtk_hbox_new (FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);
  gtk_container_add(GTK_CONTAINER(frame1), hbox);
  gtk_widget_show(hbox); 

  /* vbox --------------------------------------------------------------*/
  vbox = gtk_vbox_new (FALSE, 0);
  /*  gtk_container_add (GTK_CONTAINER (hbox), vbox);*/
  gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);
  gtk_widget_show (vbox);

  entry = text_entry_create("Periodo:", PERIODO_DIG, HORIZ, 5, &periodo_in);
  /*  gtk_container_add(GTK_CONTAINER(vbox), entry);*/
  gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, FALSE, 0);
  gtk_widget_show(entry);

  entry = text_entry_create("Excentricidad:", EXCENTRICIDAD_DIG, HORIZ, 5, &excentricidad_in);
  /*  gtk_container_add(GTK_CONTAINER(vbox), entry);*/
  gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, FALSE, 0);
  gtk_widget_show(entry);

  entry = text_entry_create("Ep. vel. max.:", EPVMAX_DIG, 
			    HORIZ, 5, &epoca_vel_max_in);
  /*  gtk_container_add(GTK_CONTAINER(vbox), entry);*/
  gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, FALSE, 0);
  gtk_widget_show(entry);

  entry = text_entry_create("V0:", V0_DIG, HORIZ, 5, &V0_in);
  /*  gtk_container_add(GTK_CONTAINER(vbox), entry);*/
  gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, FALSE, 0);
  gtk_widget_show(entry);

  entry = text_entry_create("Z1:", Z1_DIG, HORIZ, 5, &Z1_in);
  /*  gtk_container_add(GTK_CONTAINER(vbox), entry);*/
  gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, FALSE, 0);
  gtk_widget_show(entry);

  entry = text_entry_create("Z2:", Z2_DIG, HORIZ, 5, &Z2_in);
  /*  gtk_container_add(GTK_CONTAINER(vbox), entry);*/
  gtk_box_pack_start (GTK_BOX (vbox), entry, FALSE, FALSE, 0);
  gtk_widget_show(entry);

  /* vbox --------------------------------------------------------------*/
  vbox = gtk_vbox_new (FALSE, 5);
  /*  gtk_container_add (GTK_CONTAINER (hbox), vbox);*/
  gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);
  gtk_widget_show (vbox);

  frame2 = primaria_create();
  gtk_container_add(GTK_CONTAINER(vbox), frame2);
  gtk_widget_show(frame2);    

  frame2 = secundaria_create();
  gtk_container_add(GTK_CONTAINER(vbox), frame2);
  gtk_widget_show(frame2);

  return frame1;
}



GtkWidget *metodo_create()
{

  GtkWidget *main_vbox;
  GtkWidget *vbox;
  GtkWidget *frame1;
  GtkWidget *button;
  GSList *group;

  main_vbox = gtk_vbox_new (FALSE, 0);

  frame1 = gtk_frame_new(NULL);
  gtk_frame_set_label( GTK_FRAME(frame1), "Metodo" );
  gtk_frame_set_shadow_type( GTK_FRAME(frame1), GTK_SHADOW_ETCHED_IN);
  gtk_box_pack_start (GTK_BOX (main_vbox), frame1, FALSE, FALSE, 0);
  /*  gtk_container_add (GTK_CONTAINER (main_vbox), frame1);*/
  gtk_widget_show (frame1);
  /* vbox (slech. Sterne )----------------------------------------------*/
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame1), vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);
  gtk_widget_show (vbox);


  button = gtk_radio_button_new_with_label (NULL, "Slechlesinger");
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);
  gtk_widget_show (button);

  group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));

  button = gtk_radio_button_new_with_label(group, "Sterne");
  if( sterne_flag )
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), FALSE);
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (slech_sterne_callback), NULL);
  gtk_widget_show (button);

  return main_vbox;
}

GtkWidget *opciones_create()
{
  GtkWidget *main_vbox;
  GtkWidget *vbox;
  GtkWidget *frame1, *frame2;
  GtkWidget *check;

  main_vbox = gtk_vbox_new (FALSE, 0);

  frame1 = gtk_frame_new(NULL);
  gtk_frame_set_label( GTK_FRAME(frame1), "Opciones" );
  gtk_frame_set_shadow_type( GTK_FRAME(frame1), GTK_SHADOW_ETCHED_IN);
  /*  gtk_container_add (GTK_CONTAINER(main_vbox), frame1);*/
  /*  gtk_box_pack_start (GTK_BOX (main_vbox), frame1, TRUE, TRUE, 0);*/
  gtk_box_pack_start (GTK_BOX (main_vbox), frame1, FALSE, FALSE, 0);
  gtk_widget_show(frame1);

  /* vbox (periodo, excentricidad, metodo) -----------------------------*/
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame1), vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 5);
  gtk_widget_show (vbox);
  
  check = gtk_check_button_new_with_label("Periodo Variable");
  /*  gtk_container_add (GTK_CONTAINER(vbox), check);*/
  gtk_box_pack_start (GTK_BOX (vbox), check, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT(check), "toggled",
		      GTK_SIGNAL_FUNC(periodo_variable_callback),NULL);
  if(periodo_variable_flag)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), TRUE);
  else
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), FALSE);
  gtk_widget_show(check);

  check = gtk_check_button_new_with_label("Excentricidad Variable");
  /*gtk_container_add (GTK_CONTAINER(vbox), check);*/
  gtk_box_pack_start (GTK_BOX (vbox), check, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT(check), "toggled",
		      GTK_SIGNAL_FUNC(excentricidad_variable_callback),NULL);
  if(excentricidad_variable_flag)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), TRUE);
  else
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), FALSE);
  gtk_widget_show(check);

  frame2 = metodo_create();
  /*gtk_container_add(GTK_CONTAINER(vbox), frame2);*/
  gtk_box_pack_start (GTK_BOX (vbox), frame2, FALSE, FALSE, 0);
  gtk_widget_show(frame2);


  return main_vbox;
}



GtkWidget *valores_iniciales_create()
{
  GtkWidget *hbox;
  GtkWidget *main_vbox;
  GtkWidget *button;
  GtkWidget *label;
  GtkWidget *frame1, *frame2;
  GtkWidget *val_in_vbox;
  GtkWidget *file_data_entry;
  GtkWidget *check;

  main_vbox = gtk_vbox_new (FALSE, 0);
 
  frame1 = gtk_frame_new(NULL);
  gtk_frame_set_label( GTK_FRAME(frame1), "Valores iniciales" );
  gtk_frame_set_shadow_type( GTK_FRAME(frame1), GTK_SHADOW_ETCHED_IN);
  gtk_container_add(GTK_CONTAINER(main_vbox), frame1);
  gtk_widget_show(frame1); 

  val_in_vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add(GTK_CONTAINER (frame1), val_in_vbox);
  gtk_widget_show(val_in_vbox); 

  /* hbox (archivo de datos, browse, primaria, secundaria)--------------*/
  hbox = gtk_hbox_new (FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);
  /*  gtk_container_add(GTK_CONTAINER(val_in_vbox), hbox);*/
  gtk_box_pack_start (GTK_BOX (val_in_vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox); 

  label = gtk_label_new ("Archivo de datos:");
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
  /*  gtk_container_add (GTK_CONTAINER (hbox), label);*/
  gtk_widget_show (label);
  
  file_data_entry =  gtk_entry_new_with_max_length( _NAME_MAX);
  gtk_signal_connect(GTK_OBJECT(file_data_entry), "activate",
		     GTK_SIGNAL_FUNC(file_data_callback),
		     file_data_entry);
  /*  gtk_container_add (GTK_CONTAINER (hbox), file_data_entry); */
  gtk_box_pack_start (GTK_BOX (hbox), file_data_entry, FALSE, FALSE, 0);
  gtk_widget_show (file_data_entry);       
  archivo_in = file_data_entry;

  button = gtk_button_new_with_label("...");
  gtk_signal_connect(GTK_OBJECT (button), "clicked",
		     GTK_SIGNAL_FUNC (selec_file_callback),
  		     GTK_OBJECT (archivo_in));
  /*  gtk_container_add(GTK_CONTAINER (hbox), button);*/
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 0);
  gtk_widget_show(button);

  check = gtk_check_button_new_with_label("Primaria");
  /*  gtk_container_add (GTK_CONTAINER(hbox), check);*/
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT(check), "toggled",
		      GTK_SIGNAL_FUNC(use_primaria_callback), NULL);
  gtk_widget_show(check);
  check_primaria = check;

  check = gtk_check_button_new_with_label("Secundaria");
  /*  gtk_container_add (GTK_CONTAINER(hbox), check);*/
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT(check), "toggled",
		      GTK_SIGNAL_FUNC(use_secundaria_callback), NULL);
  gtk_widget_show(check);
  check_secundaria = check;
  /*----------------------------------------------------------------hbox*/

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 5);
  /*  gtk_container_add(GTK_CONTAINER(val_in_vbox), hbox);*/
  gtk_box_pack_start (GTK_BOX (val_in_vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox); 

  frame2 = opciones_create();
  /*  gtk_container_add(GTK_CONTAINER(hbox), frame2);*/
  gtk_box_pack_start (GTK_BOX (hbox), frame2, FALSE, FALSE, 0);
  gtk_widget_show(frame2);

  frame2 = parametros_create();
  /*gtk_container_add(GTK_CONTAINER(hbox), frame2);*/
  gtk_box_pack_start (GTK_BOX (hbox), frame2, FALSE, FALSE, 0);
  gtk_widget_show(frame2);    

  /*----------------------------------------------------------------hbox*/


  return main_vbox;
}


int my_gtk_create()
{
  //  GtkWidget *window;
  GtkWidget *button;
  GtkWidget *main_vbox;
  GtkWidget *bbox;
  GtkWidget *separator;
  GtkWidget *label;
  GtkWidget *frame;
  /*  GtkWidget *event_box;*/

  /* El browser de archivos: */

  /* Create a new file selection widget */
  filew = gtk_file_selection_new ("Archivo de datos");
  gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION (filew));
  /*
  gtk_signal_connect (GTK_OBJECT (filew),"delete_event",
		      (GtkSignalFunc) gtk_widget_hide, GTK_OBJECT (filew));
  gtk_signal_connect_object(
    GTK_OBJECT(GTK_FILE_SELECTION (filew)->cancel_button),
    "clicked", (GtkSignalFunc) gtk_widget_hide,
    GTK_OBJECT (filew));
  */
  gtk_signal_connect(
    GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
    "clicked", (GtkSignalFunc) file_cancel_sel_callback, filew );
  gtk_signal_connect(
    GTK_OBJECT (filew),"delete_event",
    (GtkSignalFunc) file_cancel_sel_callback ,GTK_OBJECT ( filew ));

  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
		      "clicked", (GtkSignalFunc) file_ok_sel_callback, filew );
  /* END:  browser de archivos */

  /* Create a main window */
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  //gtk_widget_set_usize(window, 500, 300);  /* ojo ACA */
  gtk_window_set_title (GTK_WINDOW (window), "Gbart");
  gtk_signal_connect (GTK_OBJECT (window), "delete_event",
		      GTK_SIGNAL_FUNC (delete_event), NULL);
  gtk_container_set_border_width (GTK_CONTAINER (window), 5);

  main_vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window), main_vbox);
  /* gtk_container_set_border_width (GTK_CONTAINER (main_vbox), 5); */

  label = gtk_label_new ("GTK bart");
  /*  gtk_container_add (GTK_CONTAINER (main_vbox), label);*/
  gtk_box_pack_start (GTK_BOX (main_vbox), label, FALSE, FALSE, 0); 
  gtk_widget_show (label);

  /* Create a Frame (valores iniciales) */
  frame = valores_iniciales_create();
  /*  gtk_container_add(GTK_CONTAINER(main_vbox), frame);*/
  gtk_box_pack_start (GTK_BOX (main_vbox), frame, FALSE, FALSE, 0);
  gtk_widget_show(frame);    
     

  /************************** test ***********/
  /*
  bbox = gtk_hbutton_box_new ();
  gtk_container_set_border_width (GTK_CONTAINER (bbox), 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (bbox),GTK_BUTTONBOX_EDGE );
  gtk_box_pack_start (GTK_BOX (main_vbox), bbox, FALSE, FALSE, 0);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (bbox), W_BUTTON, H_BUTTON);
  gtk_widget_show (bbox);
  
  button = gtk_button_new_with_label ("button 1");
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (callback_button_1), 
		      (gpointer) "button 1");
  gtk_container_add (GTK_CONTAINER (bbox), button);
  //gtk_button_box_set_child_size (GTK_BUTTON_BOX (bbox), W_BUTTON, H_BUTTON);
  gtk_widget_show (button);
  
  button = gtk_button_new_with_label ("button 2");
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (callback_button_2), 
		      (gpointer) "button 2");
  gtk_container_add (GTK_CONTAINER (bbox), button);

  gtk_widget_show (button);
  gtk_widget_show (bbox);
  */
  /************************** END: test ***********/

  /* Insert separator */
  separator = gtk_hseparator_new ();
  /*gtk_container_add (GTK_CONTAINER (main_vbox), separator);*/
  gtk_box_pack_start (GTK_BOX (main_vbox), separator, FALSE, FALSE, 0);
  gtk_widget_set_usize (separator, -2, 20);
  gtk_widget_show (separator);

  messages_windows = create_messages_window();
  gtk_box_pack_start (GTK_BOX (main_vbox), messages_windows, TRUE, TRUE, 0);
  gtk_widget_show (messages_windows);
  print_mess("Messages window started");

  /* Insert separator */
  separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (main_vbox), separator, FALSE, FALSE, 0);
  gtk_widget_set_usize (separator, -2, 20);
  gtk_widget_show (separator);

  bbox = gtk_hbutton_box_new ();
  gtk_container_set_border_width (GTK_CONTAINER (bbox), 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (bbox),GTK_BUTTONBOX_START);
  /*  gtk_button_box_set_spacing (GTK_BUTTON_BOX (bbox), 20); */

  /*gtk_container_add (GTK_CONTAINER (main_vbox), bbox);*/
  gtk_box_pack_start (GTK_BOX (main_vbox), bbox, FALSE, FALSE, 0);
  gtk_widget_show (bbox);
  /* Create "Salir" button */
  button = gtk_button_new_with_label ("Salir");
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (bbox),  W_BUTTON, H_BUTTON);
  /* When the button is clicked, we call the "delete_event" function
   * and the program exits */
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (delete_event), NULL);
  /*  gtk_container_add (GTK_CONTAINER (bbox), button);*/
  gtk_box_pack_start (GTK_BOX (bbox), button, FALSE, FALSE, 0);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  /*gtk_widget_grab_default (button); */
  gtk_widget_show (button);
  
  /* Create "Calcular" button */
  button = gtk_button_new_with_label ("Calcular");
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (bbox),  W_BUTTON, H_BUTTON);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC(calcular_callback), NULL);
  gtk_box_pack_start (GTK_BOX (bbox), button, FALSE, FALSE, 0);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button); 
  gtk_widget_show (button);

  /* La funcion de calculo: */
  /*
  event_box = gtk_event_box_new ();
  gtk_container_add(GTK_CONTAINER(window), event_box);
  gtk_widget_show (event_box);
  gtk_widget_set_events (event_box, GDK_BUTTON_PRESS_MASK);
  gtk_signal_connect (GTK_OBJECT(event_box), "button_press_event",
                        GTK_SIGNAL_FUNC (callback_button_1), NULL);
  gtk_widget_realize (event_box);
  */
  /* end */
  gtk_widget_show (main_vbox);
  gtk_widget_show (window);

  if(primaria_activa_flag)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_primaria), TRUE);
  else
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_primaria), FALSE);
  if(secundaria_activa_flag)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_secundaria), TRUE);
  else
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_secundaria), FALSE);
  
  return 0;
}




