/****************************************************************************
* Modulo : gbart_gtk_messages.c
* Fecha  : 05/10/1999
* Autor  : Federico Bareilles
* Descripcion:
*
* 
*****************************************************************************/
#include <stdarg.h>
#include "gbart_gtk.h"
#include "gbart_gtk_callback.h"
#include "gbart.h"

GtkWidget *messages_windows;

/* Locales: */
GtkWidget *messages_list;
GtkAdjustment *messages_adj;
int messages_start_flag = 0;


int print_mess(const char *format, ...)
{
  GtkWidget *list_item;
  char buffer[256];
  va_list ap;
  int ret;

  va_start(ap, format);
  ret = vsprintf(buffer, format, ap);
  if( *(buffer+ret-1) == 0x0a){
    *(buffer+ret-1) = 0  ;
    ret--;
  }
  if( messages_start_flag ){
    list_item = gtk_list_item_new_with_label (buffer);
    gtk_container_add (GTK_CONTAINER(messages_list), list_item);
    gtk_widget_show (list_item);
    gtk_adjustment_set_value( messages_adj, messages_adj->upper );
  }
  if( verbose_flag ) g_print("%s\n", buffer);

  return ret;
}

/* Create the list of "messages" */
GtkWidget * create_messages_window(void)
{

  GtkWidget *scrolled_window;
  GtkWidget *list;

  /* Create a new scrolled window, with scrollbars only if needed */
  scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				  GTK_POLICY_AUTOMATIC,
                                    GTK_POLICY_AUTOMATIC);
  messages_adj = gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW (scrolled_window)); 
  /* Create a new list and put it in the scrolled window */
  list = gtk_list_new ();
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW (scrolled_window),
					list);
  gtk_widget_show (list);
  messages_list = list;
  messages_start_flag = 1;
  
  return scrolled_window;
}

